{$N+}
{Bezier Gorbe Interpolacioval}
Uses crt;

const numsteps=80;
type Point=record
                  X,Y : longint;
           end;

var cp : Array[1..4] of Point;  {Control Points}
    Screen : Array[0..199,0..319] of byte Absolute $0a000:$0000;
    i : integer;

Procedure CalcBezier;
var ap: Point;
    X,Y : single;
    xdelta, xdelta2, xdelta3 : single;
    ydelta, ydelta2, ydelta3 : single;
    step, step2, step3 : single;
    ax, ay : single;
    bx, by : single;
    cx, cy : single;

begin
    step := 1.0 / numsteps;   {step}
    step2 := step*step;  {step^2}
    step3 := step2*step; {step^3}

    ax := -cp[1].x + 3.0*cp[2].x - 3.0*cp[3].x + cp[4].x;
    ay := -cp[1].y + 3.0*cp[2].y - 3.0*cp[3].y + cp[4].y;
    bx := 3.0*cp[1].x - 6.0*cp[2].x + 3.0*cp[3].x;
    by := 3.0*cp[1].y - 6.0*cp[2].y + 3.0*cp[3].y;
    cx := -cp[1].x*3.0 + cp[2].x*3.0;
    cy := -cp[1].y*3.0 + cp[2].y*3.0;

    xdelta := ax*step3 + bx*step2 + cx*step;
    ydelta := ay*step3 + by*step2 + cy*step;
    xdelta2 := 6.0*ax*step3 + 2.0*bx*step2;
    ydelta2 := 6.0*ay*step3 + 2.0*by*step2;
    xdelta3 := 6.0*ax*step3;
    ydelta3 := 6.0*ay*step3;

    X:=cp[1].x;
    Y:=cp[1].y;

    for i:=0 to numsteps do
    begin
        ap.X:=round(X);
        ap.y:=round(Y);
        if (ap.X>0) and (ap.Y>0) and (ap.x<319) and (ap.y<199) then
                        Screen[ap.Y,ap.X]:=14;
        X:=X+xdelta; xdelta:=xdelta+xdelta2;xdelta2:=xdelta2+xdelta3;
        Y:=Y+ydelta; ydelta:=ydelta+ydelta2;ydelta2:=ydelta2+ydelta3;
    end;
end;

Begin
      asm
          mov ax,13h
          int 10h
      end;

      cp[1].x:=10;cp[1].y:=100;
      cp[4].x:=169;cp[4].y:=50;
      cp[2].x:=45;cp[2].y:=55;
      cp[3].x:=145;cp[3].y:=155;

      CalcBezier;

      for i:=1 to 4 do screen[cp[i].Y,cp[i].X]:=79;
      readkey;
      asm
          mov ax,03h
          int 10h
      end;
End.